RXD and dividing(hdu 6060)

版权声明:抱最大的希望,为最大的努力,做最坏的打算。 https://blog.csdn.net/qq_37748451/article/details/84347870

RXD and dividing

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 1893    Accepted Submission(s): 809


 

Problem Description

RXD has a tree T, with the size of n. Each edge has a cost.
Define f(S) as the the cost of the minimal Steiner Tree of the set S on tree T. 
he wants to divide 2,3,4,5,6,…n into k parts S1,S2,S3,…Sk,
where ⋃Si={2,3,…,n} and for all different i,j , we can conclude that Si⋂Sj=∅. 
Then he calulates res=∑ki=1f({1}⋃Si).
He wants to maximize the res.
1≤k≤n≤106
the cost of each edge∈[1,105]
Si might be empty.
f(S) means that you need to choose a couple of edges on the tree to make all the points in S connected, and you need to minimize the sum of the cost of these edges. f(S) is equal to the minimal cost

Input

There are several test cases, please keep reading until EOF.
For each test case, the first line consists of 2 integer n,k, which means the number of the tree nodes , and k means the number of parts.
The next n−1 lines consists of 2 integers, a,b,c, means a tree edge (a,b) with cost c.
It is guaranteed that the edges would form a tree.
There are 4 big test cases and 50 small test cases.
small test case means n≤100.

Output

For each test case, output an integer, which means the answer.

Sample Input

5 4 1 2 3 2 3 4 2 4 5 2 5 6

Sample Output

27

Source

2017 Multi-University Training Contest - Team 3

【题意】给你一棵树,将节点[2,n]最多分为k份,再将1节点加入到每一份,将每一份的节点连接起来,权值之和加入ans,求最大化ans。

思路:

每一个 节点与他父亲节点之间的权值的贡献就是他子树分成的份数,那我们就最大化这个份

因为每个集合都包含1这个点,
因此对于每个点都至少有一条到1的路径。可以从1开始DFS,
对于每个点u,它和父亲的边的贡献最多可以是min(sz[x], k),因为可以把x的儿子结点分在不同的k个集合里面,这些儿子结点都必须经过x和父亲的边才能到达1。
那么对于每条边都这样做一遍。一个DFS可以求出答案。

#include<bits/stdc++.h>
using namespace std;
struct Edge{
    int v,w;
}temp;
vector<Edge>ve[1000005];
int ss[1000005];
int w[1000005];
void dfs(int u,int pre);
int main(){
    int n,k;
    while(scanf("%d%d",&n,&k)!=EOF){
        for(int i=1;i<=n;i++){
            ve[i].clear();
            ss[i]=0;
            w[i]=0;
        }

        for(int i=1;i<=n-1;i++)
        {
            int u,v,w;
            scanf("%d%d%d",&u,&v,&w);
            temp.v=v;
            temp.w=w;
            ve[u].push_back(temp);
            temp.v=u;
            ve[v].push_back(temp);
        }
        dfs(1,-1);
        long long sum=0;
        for(int i=2;i<=n;i++)
        {
            sum+=(long long int)w[i]*min(ss[i],k);
        }
        printf("%lld\n",sum);
    }
    return 0;
}
void dfs(int u,int pre){
    ss[u]=1;
    int len=ve[u].size();
    for(int i=0;i<len;i++){
        int v=ve[u][i].v;
        if(v!=pre){
            w[v]=ve[u][i].w;
            dfs(v,u);
            ss[u]+=ss[v];
        }
    }
}

猜你喜欢

转载自blog.csdn.net/qq_37748451/article/details/84347870